--- php-5.4.0/ext/standard/string.c	2012-01-02 01:47:57.000000000 +0100
+++ php-5.4.0-hex2bin_patched/ext/standard/string.c	2012-03-02 18:21:06.858281344 +0100
@@ -148,41 +148,41 @@
 
 /* {{{ php_hex2bin
  */
-static char *php_hex2bin(const unsigned char *old, const size_t oldlen, size_t *newlen)
+static const unsigned char hexbinconvtab[] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
+static char *php_hex2bin(const unsigned char *hex, const size_t hexlen, size_t *outlen)
 {
-	size_t target_length = oldlen >> 1;
-	register unsigned char *str = (unsigned char *)safe_emalloc(target_length, sizeof(char), 1);
-	size_t i, j;
-	for (i = j = 0; i < target_length; i++) {
-		char c = old[j++];
-		if (c >= '0' && c <= '9') {
-			str[i] = (c - '0') << 4;
-		} else if (c >= 'a' && c <= 'f') {
-			str[i] = (c - 'a' + 10) << 4;
-		} else if (c >= 'A' && c <= 'F') {
-			str[i] = (c - 'A' + 10) << 4;
-		} else {
-			efree(str);
-			return NULL;
-		}
-		c = old[j++];
-		if (c >= '0' && c <= '9') {
-			str[i] |= c - '0';
-		} else if (c >= 'a' && c <= 'f') {
-			str[i] |= c - 'a' + 10;
-		} else if (c >= 'A' && c <= 'F') {
-			str[i] |= c - 'A' + 10;
-		} else {
-			efree(str);
-			return NULL;
-		}
-	}
-	str[target_length] = '\0';
-
-	if (newlen)
-		*newlen = target_length;
-
-	return (char *)str;
+	register size_t len = (hexlen >> 1); // div 2 
+	register unsigned char *bin, *outbin;
+	register unsigned char c;
+	
+	// Hexlen must be a multiple of 2 
+	if( (hexlen & 1) )
+		return NULL;
+	
+	
+	outbin = bin = (unsigned char*)safe_emalloc( (len+1),  sizeof(char),  1 );
+	
+	
+	if (outlen)
+		*outlen = len;
+
+	for ( ; len > 0; len--) {
+		c = *(hex++);
+//		if(c == 0xff){
+//			printf("error\n");
+//		}
+		*bin	  = (hexbinconvtab[ c ] << 4);	// mul 16
+
+
+		c = *(hex++);
+//		if(c == 0xff){
+//			printf("error\n");
+//		}
+		*(bin++) |=  hexbinconvtab[ c ];
+	}
+	
+	*bin = 0;
+	return (char *) outbin;
 }
 /* }}} */
 
